#include "Arduino.h"



#define CODE_RECEIVETEST

#ifdef CODE_SENDTEST

//https://elektro.turanis.de/html/prj151/index.html
void MIDImessage(byte command, byte data1, byte data2);

byte noteON = 144; // note on command

void setup()
{
    // set "Hairless MIDI" to the same baud rate in the preferences
    Serial.begin(115200);
}

void loop()
{
    MIDImessage(noteON, 60, 100);   // turn note on
    delay(300);
    MIDImessage(noteON, 60, 0);     // turn note off (note on with velocity 0)
    delay(200);
}

void MIDImessage(byte command, byte data1, byte data2)
{
    Serial.write(command);
    Serial.write(data1);
    Serial.write(data2);
}

#endif

#ifdef CODE_RECEIVETEST

// https://www.instructables.com/id/Send-and-Receive-...>



byte commandByte;
byte noteByte;
byte velocityByte;

byte noteOn = 144;

//light up led at pin 13 when receiving noteON message with note = 60

void checkMIDI();

void setup(){
  Serial.begin(115200);
  pinMode(13,OUTPUT);

  digitalWrite(13,HIGH);
  delay(500);
  digitalWrite(13,LOW);
}

void loop(){
  checkMIDI();
  delay(100);
  digitalWrite(13,LOW);//turn led off
}

void checkMIDI(){
  do{
    if (Serial.available()){
      commandByte = Serial.read();//read first byte
      noteByte = Serial.read();//read next byte
      velocityByte = Serial.read();//read final byte
      if (commandByte == noteOn){//if note on message
        //check if note == 60 and velocity > 0
        if (noteByte == 60 && velocityByte > 0){
          digitalWrite(13,HIGH);//turn on led
        }
      }
    }
  }
  while (Serial.available() > 2);//when at least three bytes available
}
    





#endif