#include "Arduino.h"



// https://www.instructables.com/id/Send-and-Receive-...>



byte commandByte;
byte noteByte;
byte velocityByte;

byte noteOn = 144;
byte noteOff = 128;

byte control = 176;

//light up led at pin 13 when receiving noteON message with note = 60

void checkMIDI();


#include <Servo.h>

Servo myservo;  // create servo object to control a servo

int servocenter = 90;
int servospeed = 50;

void setup(){
  Serial.begin(115200);
  pinMode(13,OUTPUT);

  myservo.attach(9);  // attaches the servo on pin 9 to the servo object

  digitalWrite(13,HIGH);
  delay(500);
  digitalWrite(13,LOW);
}

void loop(){
  checkMIDI();
  delay(10);
}

// commands https://www.midi.org/specifications-old/item/table-2-expanded-messages-list-status-bytes

void checkMIDI(){
  do{
    if (Serial.available()){
      commandByte = Serial.read();//read first byte
      noteByte = Serial.read();//read next byte
      velocityByte = Serial.read();//read final byte
      if (commandByte == noteOn){//if note on message
        //check if note == 60 and velocity > 0
        if (noteByte == 60 && velocityByte > 0){
          digitalWrite(13,HIGH);//turn on led
          myservo.write(servocenter+servospeed);                  // sets the servo position according to the scaled value
        }
      }else if (commandByte == noteOff){
        if (noteByte == 60){
          digitalWrite(13,LOW);//turn off led
          myservo.write(servocenter);
        }
      }else if (commandByte == control){
        if (noteByte == 1){
          digitalWrite(13,!digitalRead(13));//turn off led
          servocenter = 90 + map(velocityByte, 0,127,-40,40);
          myservo.write(servocenter);
        }
      }
    }
  }
  while (Serial.available() > 2);//when at least three bytes available
}
    
